#ifndef SpielKlasse_H
#define SpielKlasse_H

#include "SpielV.h"
#include "Spieler\Spieler.h"
#include "Karte\Karte.h"
#include "Chat\Chat.h"
#include "Ende\Ende.h"
#include "Bestenliste\Bestenliste.h"
#include "..\Netzwerk\STKNachricht.h"
#include "Schuss\Laser.h"
#include <Bildschirm.h>
#include "Objekt/SpielObjekt.h"

class SpielKlasse : public SpielV
{
private:
	RCArray< STKNachricht > *stkn;
	int stkna;
	Bestenliste *bestenliste;
	Schrift *schrift;
    KSGClient::InformationServerClient *infoKlient;
    KSGClient::SpielServerClient *spielKlient;
	RCArray< Spieler > *spieler;
	RCArray< Team > *teams;
	RCArray< SpielObjekt > *objekte;
	Bildschirm *screen;
	Karte *map;
	Kamera *kam;
	SpielChat *chat;                                                                                                   
	Ende *end;
	RCArray< Laser > *schsse;
	Model2DData *shipData;
	Bild *shipTextur;
	SpielerGUI *ship;
    Datei csv;
    RCArray< DeadPlayer > *deads;
	bool rendern;
	int spielZeit;
	double rZeit;
	int spielerAnzahl;
	int karteId;
	int ladenProzent;
	int spielerNummer;
	char *tasten;
	int mx;
	int my;
	bool spielPause;
	int ref;
	bool istAmLeben() const;

public:
	// Konstruktor
	SpielKlasse();
	// Destruktor
	~SpielKlasse();
	// nicht constant
	void lock();
	void unlock();
	void setSchrift( Schrift *schrift ) override; // call 4
	void setBildschirm( Bildschirm *screen ) override; // call 3
	void nachricht( int ln, char *bytes ) override;
	void setKlients( KSGClient::InformationServerClient *infoKlient, KSGClient::SpielServerClient *spielKlient ) override; // call 2
	void setKarteId( int karteId ) override; // call 1
	void ladeDaten() override; // call 5
	void doMausEreignis( MausEreignis &me ) override;
	void doTastaturEreignis( TastaturEreignis &te ) override;
	void stknVerarbeitung();
	bool tick( double zeit ) override;
	void render( Bild &zRObj ) override;
	// constant
	int luft() const override;
	// Reference Counting
	SpielV *getThis() override;
	SpielV *release() override;
};

#endif